SystemOrganization addCategory: #'Xpf-Multipoint-Core'!

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:53'!
deviceSemaphore

	^ deviceSemaphore ifNil: [self deviceSemaphore: Semaphore new. deviceSemaphore]! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:07'!
deviceSemaphore: anObject

	deviceSemaphore := anObject.! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:53'!
eventSemaphore

	^ eventSemaphore ifNil: [self eventSemaphore: Semaphore new. eventSemaphore]! !

!MultiPointer class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:07'!
eventSemaphore: anObject

	eventSemaphore := anObject.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:10'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 16:42'!
getPointerCurrentState: aPointerID

	| result |
	result := MultiPointerState new.
	self pvtGetPointerCurrentState: aPointerID with: result.
	^ result! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:30'!
getPointerLively: aPointerID

	^ (self pvtGetPointerLively: aPointerID) ~= 0! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerCurrentState: aPointerID with: aMultiPointerState

	<primitive: 'primitiveMultiPointerCurrentState' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerLively: aPointerID

	<primitive: 'primitiveMultiPointerLively' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'mig 5/6/2009 22:11'!
registerSemaphore

	self setPointerEventSemaphoreHandle: (Smalltalk registerExternalObject: self eventSemaphore).
	self setPointerDeviceSemaphoreHandle: (Smalltalk registerExternalObject: self deviceSemaphore).! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
setPointerDeviceSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerDeviceSemaphoreHandle' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:11'!
setPointerEventSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerEventSemaphoreHandle' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/29/2009 19:02'!
unregisterSemaphore

	self setPointerEventSemaphoreHandle: 0.
	self setPointerDeviceSemaphoreHandle: 0.
	
	Smalltalk unregisterExternalObject: self eventSemaphore.
	Smalltalk unregisterExternalObject: self deviceSemaphore.
	
	self eventSemaphore: nil.
	self deviceSemaphore: nil.
! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:12'!
useHardwareMouse

	<primitive: 'primitiveMultiPointerUseHardwareMouse' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 5/6/2009 22:12'!
useSoftwareMouse

	<primitive: 'primitiveMultiPointerUseSoftwareMouse' module: 'MultiPointerPlugin'>
	self primitiveFailed.! !

Object subclass: #MultiPointerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

MultiPointerManager class
	instanceVariableNames: 'keyboardHand deviceUpdateProcess movementProcess handMorphs multiPointerActive'!

MultiPointerManager class
	instanceVariableNames: 'keyboardHand deviceUpdateProcess movementProcess handMorphs multiPointerActive'!

!MultiPointerManager class methodsFor: 'private' stamp: 'mig 5/6/2009 23:06'!
colorizeHands

	| colorWheel |
	colorWheel := Color wheel: self handMorphs size.
	
	self handMorphs withIndexDo: [:hand :index |
		hand normalCursor: (MultiPointerHandMorph 
			cursorColored: (colorWheel at: index) 
			with: (self keyboardHand = hand ifTrue: [Color black] ifFalse: [Color white]))].! !

!MultiPointerManager class methodsFor: 'private' stamp: 'mig 5/6/2009 22:14'!
createHandMorphForMouse: aMouseID

	self pluginAvailable ifFalse: [^ nil].
	
	^ self handMorphs
		detect: [:each | each mouseID = aMouseID]
		ifNone: [ | m |
			m := MultiPointerHandMorph new mouseID: aMouseID.
			self handMorphs add: m.
			self multiPointerActive ifTrue: [World addHand: m]].! !

!MultiPointerManager class methodsFor: 'private' stamp: 'SR 5/6/2009 14:22'!
destroyHandMorphForMouse: aMouseID

	| m |
	self pluginAvailable ifFalse: [^ self].
	
	m := self handMorphs detect: [:each | each mouseID = aMouseID] ifNone: [nil].
	m ifNotNil: [
		self handMorphs remove: m.
		World removeHand: m.
		self keyboardHand = m ifTrue: [
			self handMorphs
				ifEmpty: [self keyboardHand: World hands first]
				ifNotEmpty: [self keyboardHand: self handMorphs first]]].
			! !

!MultiPointerManager class methodsFor: 'processes' stamp: 'mig 5/6/2009 23:05'!
deviceUpdateBlock

	^ [[
		0 to: MultiPointer getPointerCount - 1 do: [ :each |
			(MultiPointer getPointerLively: each)
				ifTrue: [ self createHandMorphForMouse: each ]
				ifFalse: [ self destroyHandMorphForMouse: each ]].
		self colorizeHands.
		MultiPointer deviceSemaphore wait.
	] repeat ]! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:37'!
deviceUpdateProcess

	^ deviceUpdateProcess! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:15'!
deviceUpdateProcess: anObject

	deviceUpdateProcess := anObject.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
handMorphs

	^ handMorphs! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:15'!
handMorphs: anObject

	handMorphs := anObject.! !

!MultiPointerManager class methodsFor: 'class initialization' stamp: 'SR 5/6/2009 11:54'!
initialize

	super initialize.
	self handMorphs: OrderedCollection new.
	self multiPointerActive: false.
	
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 5/5/2009 22:56'!
keyboardHand

	^ keyboardHand! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:19'!
keyboardHand: anObject

	keyboardHand := anObject.
	self colorizeHands.! !

!MultiPointerManager class methodsFor: 'processes' stamp: 'mig 5/6/2009 23:06'!
movementBlock

	^ [
		[
			MultiPointer eventSemaphore wait.
			self handMorphs do: [:each |
				each enqueueEvent: (MultiPointer getPointerCurrentState: each mouseID)]
		] repeat
	]! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:51'!
movementProcess

	^ movementProcess! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:19'!
movementProcess: anObject

	movementProcess := anObject.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 5/6/2009 11:53'!
multiPointerActive

	^ multiPointerActive! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:19'!
multiPointerActive: anObject

	multiPointerActive := anObject.! !

!MultiPointerManager class methodsFor: 'testing' stamp: 'SR 5/6/2009 10:19'!
pluginAvailable

	^ SmalltalkImage current listBuiltinModules anySatisfy: [:each | each startsWith: 'MultiPointerPlugin']! !

!MultiPointerManager class methodsFor: 'event processing' stamp: 'mig 5/6/2009 22:21'!
processSystemMouseEvent: evtBuf on: aHandMorph
	
	(self pluginAvailable and: [self multiPointerActive])
		ifFalse: [^ aHandMorph generateMouseEvent: evtBuf].
	
	^ nil! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'mig 5/6/2009 23:10'!
shutDown: aboutToQuit 

	self pluginAvailable ifTrue: [
		self multiPointerActive ifTrue: [self stopMoving].
		self stopDeviceDiscovery.
		MultiPointer unregisterSemaphore].
	
	super shutDown: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'mig 5/6/2009 23:05'!
startDeviceDiscovery

	self pluginAvailable ifFalse: [^ self].
	self deviceUpdateProcess ifNotNil: [^self].
	self deviceUpdateProcess: self deviceUpdateBlock fork.
	
	self deviceUpdateProcess name: 'MultiPointer Device Discovery'.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'mig 5/6/2009 23:06'!
startMoving

	self pluginAvailable ifFalse: [^ self].
	self movementProcess ifNotNil: [^ self].
		
	self handMorphs do: [:hand | 
		World addHand: hand.
		MultiPointer getPointerCurrentState: hand mouseID].

	self keyboardHand: self handMorphs first.

	self multiPointerActive: true.
	MultiPointer useSoftwareMouse.
	
	self movementProcess: self movementBlock fork.
	
	self movementProcess
		name: 'MultiPointer Movement';
		priority: Processor userInterruptPriority.! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'mig 5/6/2009 23:10'!
startUp: aboutToQuit 

	self pluginAvailable ifTrue: [
		MultiPointer registerSemaphore.
		self startDeviceDiscovery].
	
	super startUp: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'SR 5/6/2009 11:14'!
stopDeviceDiscovery

	self pluginAvailable ifFalse: [^ self].
	self deviceUpdateProcess ifNotNil: [
		self deviceUpdateProcess terminate.
		self deviceUpdateProcess: nil.
		1 to: MultiPointer getPointerCount do: [:each |
			self destroyHandMorphForMouse: (each-1)].
		self handMorphs: OrderedCollection new].
! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'SR 5/6/2009 11:54'!
stopMoving

	self pluginAvailable ifFalse: [^ self].

	self movementProcess ifNotNil: [
		self movementProcess terminate.
		self movementProcess: nil].
	
	self handMorphs do: [:each | World removeHand: each].
	MultiPointer useHardwareMouse.

	Sensor eventQueue flush.
	self multiPointerActive: false.
	self keyboardHand: nil.
! !

Object subclass: #MultiPointerState
	instanceVariableNames: 'x y buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons

	^ buttons! !

!MultiPointerState methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:24'!
buttons: anObject

	buttons := anObject.! !

!MultiPointerState methodsFor: 'printing' stamp: 'SR 4/29/2009 16:50'!
printOn: aStream 
	"The receiver prints on aStream in terms of infix notation."

	x printOn: aStream.
	aStream nextPut: $@.
	y printOn: aStream.
	aStream nextPut: $@.
	buttons printOn: aStream.! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x

	^ x! !

!MultiPointerState methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:24'!
x: anObject

	x := anObject.! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y

	^ y! !

!MultiPointerState methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:24'!
y: anObject

	y := anObject.! !

Object subclass: #MultiPointerWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'SR 5/5/2009 23:18'!
createButton: actionSel label: labelSel
	
	| btn |
	btn := UITheme current
		newLabelIn: World
		label: labelSel. 
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	btn on: #mouseUp send: actionSel to: self.
	^ btn
	! !

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'mig 5/6/2009 22:26'!
grabKeyboardWithEvent: evt from: source

	MultiPointerManager multiPointerActive
		ifTrue: [MultiPointerManager keyboardHand: evt hand].! !

!MultiPointerWidget class methodsFor: 'user interface' stamp: 'mig 5/6/2009 22:25'!
open
	
	(AlignmentMorph newBounds: (50@50 corner: 700@80))
		color: Color yellow;
		addMorph: (self createButton: #grabKeyboardWithEvent:from: label: 'Grab Keyboard');
		openInWorld.! !

!HandMorph methodsFor: '*xpf-multipoint-core-override' stamp: 'SR 5/6/2009 11:54'!
processEvents
	"Process user input events from the local input devices."

	| evt evtBuf type hadAny handleCurrentEvent |
	ActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response.
		Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].
	
	hadAny := false.
	[(evtBuf := Sensor nextEvent) isNil] whileFalse: [
		evt := nil.	"for unknown event types"
		handleCurrentEvent := true.
		type := evtBuf first.
		
		type = EventTypeMouse
			ifTrue: [
				evt := MultiPointerManager processSystemMouseEvent: evtBuf on: self.
				evt ifNil: [handleCurrentEvent := false]].
		type = EventTypeKeyboard 
			ifTrue: [evt := self generateKeyboardEvent: evtBuf].
		type = EventTypeDragDropFiles 
			ifTrue: [evt := self generateDropFilesEvent: evtBuf].
		"All other events are ignored"
		(type ~= EventTypeDragDropFiles and: [evt isNil]) ifTrue: [^self].
		(evt isNil not and: [handleCurrentEvent]) ifTrue: [
			MultiPointerManager multiPointerActive
				ifTrue: [MultiPointerManager keyboardHand enqueueEvent: evt]
				ifFalse: [
					"Finally, handle it"
					self handleEvent: evt.
					hadAny := true.

					"For better user feedback, return immediately after a mouse event has been processed."
					(evt isMouse and: [evt isMouseWheel not]) ifTrue: [^self]
				]
		]
	].
	
	"note: if we come here we didn't have any mouse events"
	mouseClickState notNil ifTrue: [
		"No mouse events during this cycle. Make sure click states time out accordingly"
		mouseClickState handleEvent: lastMouseEvent asMouseMove from: self].
	
	hadAny ifFalse: [
		"No pending events. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent]! !

HandMorph subclass: #MultiPointerHandMorph
	instanceVariableNames: 'queue lastPosition buttons mouseID normalCursor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Core'!

!MultiPointerHandMorph class methodsFor: 'misc' stamp: 'mig 5/6/2009 22:06'!
cursorColored: aColor with: anotherColor

	^ (NormalCursor deepCopy) 
		replaceColor: Color black withColor: aColor;
		replaceColor: Color white withColor: anotherColor;
		yourself! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:49'!
buttons

	^ buttons! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:21'!
buttons: newButtons

	buttons := newButtons.! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:52'!
createMorphicButtonEvents: aState

	| result |
	result := OrderedCollection new.
	0 to: 2 do: [:each |
		(aState buttons anyMask: (1 bitShift: each*2)) ifTrue: [
			self buttons: (self buttons bitOr: (1 bitShift: (2-each))).
			result add: (MouseButtonEvent new 
				setType: #mouseDown
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
		(aState buttons anyMask: (1 bitShift: (each*2)+1)) ifTrue: [
			self buttons: (self buttons bitAnd: ((1 bitShift: (2-each)) bitInvert)).
			result add: (MouseButtonEvent new 
				setType: #mouseUp
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
	].
	^ result! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 5/4/2009 10:37'!
createMorphicMoveEvent: aState

	| newPosition evt tempPoint |
	tempPoint := Point x: aState x y: aState y.
	newPosition := self lastPosition + tempPoint.
	
	newPosition = self lastPosition ifTrue: [^ nil].
	
	newPosition := newPosition adhereTo: Display fullBoundingBox.
	evt := MouseMoveEvent new
		setType: #mouseMove
		startPoint: self lastPosition
		endPoint: newPosition
		trail: nil
		buttons: self buttons
		hand: self
		stamp: Time millisecondClockValue.
	self lastPosition: newPosition.
	^ evt! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'mig 5/6/2009 22:23'!
drawOn: aCanvas 
	"Draw the hand itself (i.e., the cursor)."

	aCanvas 
		paintImage: ({self temporaryCursor. self normalCursor. NormalCursor} detect: [:cursor| cursor notNil])
		at: bounds topLeft.! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'SR 5/5/2009 23:03'!
enqueueEvent: aState

	aState isMorphicEvent
		ifTrue: [self queue nextPut: aState]
		ifFalse: [
			self queue nextPut: (self createMorphicMoveEvent: aState).
			aState buttons isZero ifFalse: [
				self queue nextPutAll: (self createMorphicButtonEvents: aState)]].! !

!MultiPointerHandMorph methodsFor: 'as yet unclassified' stamp: 'mig 5/15/2009 10:47'!
handId

	^ self mouseID asString
! !

!MultiPointerHandMorph methodsFor: 'initialization' stamp: 'SR 4/29/2009 17:53'!
initialize

	super initialize.
	self queue: SharedQueue new.
	self lastPosition: 0 asPoint.
	self buttons: 0.
! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition

	^ lastPosition! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition: anObject

	lastPosition := anObject! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID

	^ mouseID! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID: anObject

	mouseID := anObject! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'SR 4/24/2009 13:39'!
needsToBeDrawn

	^ true! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 10:41'!
normalCursor

	^ normalCursor! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 10:42'!
normalCursor: anObject

	normalCursor := anObject.! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'mig 5/7/2009 13:54'!
processEvents
	
	ActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].
	
	self queue isEmpty ifTrue: [
		"No pending events. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent.
		^ self].

	[self queue isEmpty] whileFalse: [
		self handleEvent: self queue next].! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue

	^ queue! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'mig 5/6/2009 22:21'!
queue: anObject

	queue := anObject.! !

!SharedQueue methodsFor: '*xpf-multipoint-core-override' stamp: 'SR 5/4/2009 10:34'!
nextPut: value 
	"Send value through the receiver. If a Process has been suspended 
	waiting to receive a value through the receiver, allow it to proceed."

	value ifNil: [^ self].
	accessProtect
		critical: [writePosition > contentsArray size
						ifTrue: [self makeRoomAtEnd].
				 contentsArray at: writePosition put: value.
				 writePosition := writePosition + 1].
	readSynch signal.
	^value! !

!SharedQueue methodsFor: '*xpf-multipoint-core' stamp: 'SR 4/29/2009 17:24'!
nextPutAll: aCollection

	aCollection do: [:each | self nextPut: each].! !

!Morph methodsFor: '*xpf-multipoint-core-override' stamp: 'SR 5/6/2009 14:25'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	self removeHalo.
	aWorld := self world ifNil: [World].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil: [
		self disableSubmorphFocusForHand: self activeHand.
		self activeHand ifNotNil: [
			self activeHand
				releaseKeyboardFocus: self;
				 releaseMouseFocus: self]].
	owner ifNotNil:[ self privateDelete.
		self player ifNotNilDo: [ :player |
			"Player must be notified"
			player noteDeletionOf: self fromWorld: aWorld]].! !
MultiPointerManager initialize!
